package robust.pm.dao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import robust.pm.entity.ProjectMemEntity;


public class ProjectMemDAO {
	//ͺ̽    
	private Connection conn = null;
	private PreparedStatement pstmt = null;


	//ͺ̽    ڿ 
	private String jdbc_driver = "com.mysql.jdbc.Driver";
	private String jdbc_url = "jdbc:mysql://localhost:3306/robust";

	void connect() {
		//JDBC ̹ ε
		try {
			Class.forName(jdbc_driver); //ε
			//ͺ̽  ̿ connection νϽ Ȯ
			conn = (Connection) DriverManager.getConnection(jdbc_url,
					"robust", "robust"); //
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	void disconnect() {
		if (pstmt != null) {
			try {
				pstmt.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		if (conn != null) {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}

	public boolean insertDB(ProjectMemEntity projectMem) {
		connect();
		//ϴ entity ּóѰ͵ Ƚ!
		String sql = "insert into tuser(user_nm,last_sch_cd,major_nm,foreign_cap_cd,org_nm,dept_cd,post_cd,email,tel_no,hp_no,del_yn,reg_dtm,user_image) values(?,?,?,?,?,?,?,?,?,?,?,?,C:/JAVA/JavaBasic/workspace/StudyJSP/̻۰.jpg)";

		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, projectMem.getUser_nm());
			pstmt.setString(2, projectMem.getLast_sch_cd());
			pstmt.setString(3, projectMem.getMajor_nm());
			pstmt.setString(4, projectMem.getForeign_cap_cd());
			pstmt.setString(5, projectMem.getOrg_nm());
			pstmt.setString(6, projectMem.getDept_cd());
			pstmt.setString(7, projectMem.getPost_cd());
			pstmt.setString(8, projectMem.getEmail());
			pstmt.setString(9, projectMem.getTel_no());
			pstmt.setString(10, projectMem.getHp_no());
			pstmt.setString(11, projectMem.getDel_yn());
			pstmt.setString(12, projectMem.getReg_dtm());
			pstmt.setString(13, projectMem.getUser_image());
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			disconnect();
		}

		return true;
	}


	//̹ Ǿ ִ  ϴ 
	public boolean updateDB(ProjectMemEntity projectMem) {
		connect();

		String sql = "update tuser set user_nm=?,user_grp_cd=?,last_sch_cd=?,major_nm=?,foreign_cap_cd=?,org_nm=?,dept_cd=?,post_cd=?,email=?,tel_no=?,hp_no=?,del_yn=?,reg_dtm=?, user_image=C:/JAVA/JavaBasic/workspace/StudyJSP/̻۰.jpg where user_id=?";
	
		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, projectMem.getUser_nm());
			pstmt.setString(2, projectMem.getUser_grp_cd());
			pstmt.setString(3, projectMem.getLast_sch_cd());
			pstmt.setString(4, projectMem.getMajor_nm());
			pstmt.setString(5, projectMem.getForeign_cap_cd());
			pstmt.setString(6, projectMem.getOrg_nm());
			pstmt.setString(7, projectMem.getDept_cd());
			pstmt.setString(8, projectMem.getPost_cd());
			pstmt.setString(9, projectMem.getEmail());
			pstmt.setString(10, projectMem.getTel_no());
			pstmt.setString(11, projectMem.getHp_no());
			pstmt.setString(12, projectMem.getDel_yn());
			pstmt.setString(13, projectMem.getReg_dtm());
			pstmt.setString(14, projectMem.getUser_image());
			pstmt.setString(15, projectMem.getUser_id());
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			disconnect();
		}

		return true;
	}


	// Խù ϱ  ޼
	public boolean deleteDB(int user_id) {
		connect();

		String sql = "delete from tuser where user_id=?";

		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, user_id);
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			disconnect();
		}

		return true;
	}


	
	////߿ ڵ Ǵ ̺  Է½ߵ!!!><><><//////
	public ProjectMemEntity get_UserDB(int user_id) {
		connect();

		String sql = "select user_id,user_nm,last_sch_cd,major_nm,foreign_cap_cd,org_nm,dept_cd,post_cd,email,tel_no,hp_no,del_yj,reg_dtm,user_image from tuser where user_id=?";
		ProjectMemEntity projectMem = new ProjectMemEntity();

		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, user_id);
			ResultSet rs = pstmt.executeQuery();			
			rs.next();
			projectMem.setUser_id(rs.getString("user_id"));
			projectMem.setUser_nm(rs.getString("user_nm"));
			//projectMem.setUser_nm(rs.getString("password"));
			//projectMem.setUser_grp_cd(rs.getString("user_grp_cd"));
			projectMem.setLast_sch_cd(rs.getString("last_sch_cd"));
			projectMem.setMajor_nm(rs.getString("major_nm"));
			projectMem.setForeign_cap_cd(rs.getString("foreign_cap_cd"));
			projectMem.setOrg_nm(rs.getString("org_nm"));
			projectMem.setDept_cd(rs.getString("dept_cd"));
			projectMem.setPost_cd(rs.getString("post_cd"));
			projectMem.setEmail(rs.getString("email"));
			projectMem.setTel_no(rs.getString("tel_no"));
			projectMem.setHp_no(rs.getString("hp_no"));
			projectMem.setDel_yn(rs.getString("del_yn"));
			projectMem.setReg_dtm(rs.getString("reg_dtm"));
			projectMem.setUser_image(rs.getString("user_image"));
			//projectMem.setUser_nm(rs.getString("last_upd_dtm"));
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}

		return projectMem;
	}

	//Խù  ֱ  ϴ ż(͸ Ѳ ´)
	public ArrayList<ProjectMemEntity> get_UserDBList() {
		connect();
		ArrayList<ProjectMemEntity> datas = new ArrayList<ProjectMemEntity>();

		String sql = "select user_id,user_nm,last_sch_cd,major_nm,foreign_cap_cd,org_nm,dept_cd,post_cd,email,tel_no,hp_no,del_yj,reg_dtm, user_image from tuser where user_id=?";

		try {
			pstmt = conn.prepareStatement(sql);
			ResultSet rs = pstmt.executeQuery();

			while (rs.next()) {
				ProjectMemEntity projectMem = new ProjectMemEntity();

				projectMem.setUser_id(rs.getString("user_id"));
				projectMem.setUser_nm(rs.getString("user_nm"));
				//projectMem.setUser_nm(rs.getString("password"));
				//projectMem.setUser_grp_cd(rs.getString("user_grp_cd"));
				projectMem.setLast_sch_cd(rs.getString("last_sch_cd"));
				projectMem.setMajor_nm(rs.getString("major_nm"));
				projectMem.setForeign_cap_cd(rs.getString("foreign_cap_cd"));
				projectMem.setOrg_nm(rs.getString("org_nm"));
				projectMem.setDept_cd(rs.getString("dept_cd"));
				projectMem.setPost_cd(rs.getString("post_cd"));
				projectMem.setEmail(rs.getString("email"));
				projectMem.setTel_no(rs.getString("tel_no"));
				projectMem.setHp_no(rs.getString("hp_no"));
				projectMem.setDel_yn(rs.getString("del_yn"));
				projectMem.setReg_dtm(rs.getString("reg_dtm"));
				projectMem.setUser_image(rs.getString("user_image"));
				//projectMem.setUser_nm(rs.getString("last_upd_dtm"));
				datas.add(projectMem);
			}
			rs.close();

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}

		return datas;
	}
}
