package robust.pm.util;


/*
// header - edit "Data/yourJavaHeader" to customize
// contents - edit "EventHandlers/Java file/onCreate" to customize
//
*/
import java.text.FieldPosition;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;


public class DateUtil 
{   


	public static String getThisTime() {
 	
		SimpleDateFormat formatter   = new SimpleDateFormat ("HHmmss");
	 	Date currentTime_1 = new Date();
	 	String dateString = formatter.format(currentTime_1);
			
		return dateString;
			
	}

	public static String getTodayDate() {
 	
		SimpleDateFormat formatter   = new SimpleDateFormat ("yyyyMMdd");
	 	Date currentTime_1 = new Date();
	 	String dateString = formatter.format(currentTime_1);
			
		return dateString;
			
	}

  public static String getToDate(String curr_date, int amount) {
    Calendar cal = Calendar.getInstance();
    cal.set(new Integer(curr_date.substring(0, 4)).intValue(),
            new Integer(curr_date.substring(4, 6)).intValue() - 1,
            new Integer(curr_date.substring(6, 8)).intValue());

    cal.add(Calendar.DATE, amount);

    int nowYear = cal.get(Calendar.YEAR);
    int nowMonth = cal.get(Calendar.MONTH) + 1;
    int nowDay = cal.get(Calendar.DATE);

    String sYear = String.valueOf(nowYear);
    String sMonth = String.valueOf(nowMonth);
    if (sMonth.length() == 1) {
      sMonth = "0" + sMonth;
    }
    String sDay = String.valueOf(nowDay);
    if (sDay.length() == 1) {
      sDay = "0" + sDay;

    }
    String toDate = sYear + sMonth + sDay;

    return toDate;
  }
  
	public static String getThisSaturday() {
		Calendar c = Calendar.getInstance();
		c.set(c.DAY_OF_WEEK , c.SATURDAY);
		int y = c.get(c.YEAR);
		int m = c.get(c.MONTH)+1;
		int d = c.get(c.DATE);
		String yy = "";
		String mm = "";
		String dd = "";
		
		yy = String.valueOf(y);
		if(m < 10) 
			mm = "0"+String.valueOf(m);
		else
			mm = String.valueOf(m);
		
		if(d < 10)
			dd = "0"+String.valueOf(d);
		else 
			dd = String.valueOf(d);
			
		return yy+mm+dd;
	}

    public static DateStringItem getToday() {
		Calendar c = Calendar.getInstance();
		DateStringItem dItem = new DateStringItem();
		
		dItem.year = String.valueOf(c.get(c.YEAR));
    	dItem.month = String.valueOf(c.get(c.MONTH)+1);
   		dItem.day = String.valueOf(c.get(c.DATE));
			
		return dItem; 
	}
	
	
	public static DateItem getNextDay(DateItem dItem, Calendar c) {
        c.set(c.YEAR, dItem.year);
        c.set(c.MONTH, dItem.month-1);
        c.set(c.DATE, dItem.day+1);
   
        dItem.year = c.get(c.YEAR);
        dItem.month = c.get(c.MONTH)+1;
        dItem.day = c.get(c.DATE);
        return dItem;
    }

    public static String getNextDay(String yyyymmdd) {
        if(yyyymmdd == null) {
            System.err.println("[DateUtil]=>yyyymmdd is null");
            return null;
        }
        if(yyyymmdd.length() != 8) {
            System.err.println("[DateUtil]=>yyyymmdd dateFormat is wrong");
            return null;
        }
        Calendar cal = Calendar.getInstance();

        String y = yyyymmdd.substring(0,4);
        String m = yyyymmdd.substring(4,6);
        String d = yyyymmdd.substring(6,8);
        DateItem dItem = new DateItem(); 
        dItem.year = Integer.parseInt(y);
        dItem.month = Integer.parseInt(m);
        dItem.day = Integer.parseInt(d);
        dItem = getNextDay(dItem,cal);
        return dateStringFormat(dItem);
    } 
	
	

    public static DateItem getPreDay(DateItem dItem, Calendar c) {
        c.set(c.YEAR, dItem.year);
        c.set(c.MONTH, dItem.month-1);
        c.set(c.DATE, dItem.day-1);

        dItem.year = c.get(c.YEAR);
        dItem.month = c.get(c.MONTH)+1;
        dItem.day = c.get(c.DATE);
        return dItem;
    }  

    public static String getPreDay(String yyyymmdd) {
        if(yyyymmdd == null) {
            System.err.println("[DateUtil]=>yyyymmdd is null");
            return null;   
        }
        if(yyyymmdd.length() != 8) {
            System.err.println("[DateUtil]=>yyyymmdd dateFormat is wrong");
            return null;
        }
        Calendar cal = Calendar.getInstance();

        String y = yyyymmdd.substring(0,4);
        String m = yyyymmdd.substring(4,6);
        String d = yyyymmdd.substring(6,8);
        DateItem dItem = new DateItem(); 
        dItem.year = Integer.parseInt(y);
        dItem.month = Integer.parseInt(m);
        dItem.day = Integer.parseInt(d);
        dItem = getPreDay(dItem,cal);
        return dateStringFormat(dItem);
    }
	
	public static String getNextMonth(String yyyy, String mm) {
		Calendar cal = Calendar.getInstance();
		cal.set(cal.YEAR, Integer.parseInt(yyyy));
        cal.set(cal.MONTH, Integer.parseInt(mm));
        cal.set(cal.DATE, 1);

		String y = String.valueOf(cal.get(cal.YEAR)); 
		String m = "";

		int mi = cal.get(cal.MONTH)+1;
		if(mi < 10) {
			m = "0"+String.valueOf(mi);
		}else
			m = String.valueOf(mi);
		
		
		return y+m;
		//return Integer.toString(cal.get(cal.YEAR))+Integer.toString(cal.get(cal.MONTH)+1);		
		
	}

    public static String dateStringFormat(DateItem dItem) {
        String y = String.valueOf(dItem.year);
        String m = String.valueOf(dItem.month);
        String d = String.valueOf(dItem.day);
        if(dItem.month < 10)
                m = "0"+m;
        if(dItem.day < 10)     
                d = "0"+d; 
        return y+m+d;
    }   

    public static class DateItem {
        public int year;
        public int month;
        public int day;
    }
	
	public static class DateStringItem {
		public String year;
		public String month;
		public String day; 
	}
	 
	public static String getDateFormat(){
		   
	   StringBuffer sf = null;
	   Calendar date = Calendar.getInstance();
	   SimpleDateFormat sim = new SimpleDateFormat("yyyyMMddHHmmss");
	   sf = sim.format(date.getTime(),new StringBuffer(), new FieldPosition(0));
	   return sf.toString();
	} 
}

