package robust.pm.util;


/**
 * ڿ Ÿ   Ѵ.
 *
 */
public class StringFormat {
	
	/**
	 * Էµ ڿ  ð  ȯѴ.
	 * @param ymd 
	 * @return  ȯ 
	 */
	public static String getFormatOnlyDate(String ymd) {
		return getFormatDate(ymd, "/", false);
	}

	/**
	 * Էµ ڿ  ð  ȯѴ.
	 * @param ymd 
	 * @return  ȯ 
	 */
	public static String getFormatDate(String ymd) {
		return getFormatDate(ymd, "/", true);
	}
	
	/**
	 * Էµ ڿ  ð  ȯѴ.
	 * @param ymd 
	 * @return  ȯ 
	 */
	public static String getFormatDate(String ymd, String sep) {
		return getFormatDate(ymd, sep, true);
	}
	
	/**
	 * Էµ ڿ  ð  ȯѴ.
	 * @param ymd 
	 * @param sep ˺ȯ  
	 * @param bIncludeTime ð  
	 * @return  ȯ 
	 */
    public static String getFormatDate(String ymd, String sep, boolean bIncludeTime) {

        if ( ymd == null ) return "";
        StringBuffer sb = new StringBuffer();

       if(ymd.length() >= 4) {
            sb.append(ymd.substring(0,4)).append(sep);
       }
       if(ymd.length() >= 6) {
            sb.append(ymd.substring(4,6)).append(sep);
       }
       if(ymd.length() >= 8) {
            sb.append(ymd.substring(6,8));
       }

       if(ymd.length() == 14 && bIncludeTime) {
               sb.append(" ").append(getFormatTime(ymd.substring(8, 14).trim()));
       }
        
        return sb.toString();
   }

	/**
	 * Էµ ڿ ð  ȯѴ.
	 * @param ymd ð
	 * @return  ȯ ð
	 */
    public static String getFormatTime(String hms) {
        if ( hms == null ) return "";
        if ( hms.length() != 6 ) return hms;
        StringBuffer sb = new StringBuffer();
        sb.append(hms.substring(0,2)).append(":");
        sb.append(hms.substring(2,4)).append(".");
        sb.append(hms.substring(4,6));
        
        return sb.toString();
   }
    
	/**
	 * Էµ ڿ ð  ȯѴ.
	 * @param ymd ð
	 * @param sep ˺ȯ  
	 * @return  ȯ ð
	 */
    public static String getFormatTime(String hms,String sep) {
        if ( hms == null ) return "";
        if ( hms.length() != 6 ) return hms;
        StringBuffer sb = new StringBuffer();
        sb.append(hms.substring(0,2)).append(sep);
        sb.append(hms.substring(2,4)).append(sep);
        sb.append(hms.substring(4,6));
        
        return sb.toString();
   }
    
	
	/**
	 * <pre>
	 * Էµ ڸ õ , ٿ ȯѴ. 
	 * </pre>
	 * @param cnt Է 
	 * @return 
	*/
	public static String getFormatNumber(int cnt)
	{
		boolean			isNagative	= false;
		StringBuffer	sb 			= new StringBuffer();
		String			str			= null;
		
		if(cnt == 0){
			return "0";
		}
		
		if(cnt < 0) { 
			isNagative = true;
			cnt = cnt * -1;
		}
		
		while(cnt > 0) {
			
			if(cnt / 1000 > 0) {
				str = "000" + (cnt % 1000);
				sb.insert(0, str.substring(str.length() - 3));
			} else {
				sb.insert(0, (cnt % 1000));
			}

			cnt = cnt / 1000;
			
			if(cnt > 0) {
				sb.insert(0, ",");
			}
		}
        
		if(isNagative) {
			sb.insert(0, "-");
		}
		
		return sb.toString();            
	}
	
	/**
	 *  ڿ MAX SIZE ȸǵ Ѵ.
	 *  
	 *  @param sStr ڿ
	 *  @param iMaxLength ڿ 
	 *  
	 *  @return ڿ
	 */
	public static String getFormatTitle(String sStr, int iMaxLength) {
		
		String sTmpStr = null;
		
		if(StringUtil.lengthb(sStr) > iMaxLength) {
			sTmpStr = StringUtil.substringb(sStr, 0, iMaxLength);
			sTmpStr = HTMLUtil.getText(sTmpStr) + "...";
		} else {
			sTmpStr = HTMLUtil.getText(sStr);
		}
		
		return sTmpStr;
	}
	
	/**
	 *  ڿ MAX SIZE ȸǵ Ѵ.
	 *  
	 *  @param sStr ڿ
	 *  @param iMaxLength ڿ 
	 *  
	 *  @return ڿ
	 */
	public static String getFormatTitle1(String sStr, int iMaxLength) {
		
		String sTmpStr = null;
		
		if(StringUtil.lengthb(sStr) > iMaxLength) {
			sTmpStr = StringUtil.substringb(sStr, 0, iMaxLength);
			sTmpStr = HTMLUtil.getText(sTmpStr) + "..";
		} else {
			sTmpStr = HTMLUtil.getText(sStr);
		}
		
		return sTmpStr;
	}
}
