package robust.PM;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.util.Log;

public class DBHelper {

	public static String getHttpContents(String url) {

		StringBuffer pageBuffer = new StringBuffer();
		try {
			URL targetUrl = new URL(url);
			URLConnection urlConn = targetUrl.openConnection();
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					urlConn.getInputStream(), "euc-kr"));
			// Read page into buffer.
			String line;
			while ((line = reader.readLine()) != null) {
				pageBuffer.append(line + "\n");
			}
		} catch (Exception e) {
			return "";
		}
		return pageBuffer.toString();
	}
	
	public static String getID( String ID ){

		try{
			//서버에서 DB를 가져옮
			String jString = DBHelper.getHttpContents
			("http://203.253.27.222:80/service/moblie/json.jsp?userID="+ID);

			//JSONObject 얻어 오기 
			JSONObject jObject =  new JSONObject(jString); 

			//Id값을 리턴
			return jObject.getString("Id");

		}catch(JSONException je){ 
			Log.e("jsonErr", "JSON에러 입니다", je);
			return "";
		}catch(Exception e){ 
			Log.e("execption", "파일이 없습니다", e); 
			return "";
		}
	}
	
	public static String getPassword( String ID ) {

		try{
			//서버에서 DB를 가져옮
			String jString = DBHelper.getHttpContents
			("http://203.253.27.222:80/service/moblie/json.jsp?userID="+ID);
			
			//JSONObject 얻어 오기 
			JSONObject jObject =  new JSONObject(jString); 

			//Password값을 리턴
			return jObject.getString("Password");

		}catch(JSONException je){ 
			Log.e("jsonErr", "JSON에러 입니다", je);
			return "";
		}catch(Exception e){ 
			Log.e("execption", "파일이 없습니다", e); 
			return "";
		}
	}
	
	public static void getProject(String ID, ArrayList<String> project, String projName[]){

		try{
			//서버에서 DB를 가져옮
			String jString = DBHelper.getHttpContents
			("http://203.253.27.222:80/service/moblie/json.jsp?userID="+ID);
			
			//JSONObject 얻어 오기 
			JSONObject jObject =  new JSONObject(jString); 

			//JSONArray에 Project 값 넣어주기
			JSONArray jProj = new JSONArray(jObject.getString("Project"));

			for (int a = 0; a < jProj.length(); a++){

				projName[a] = jProj.getJSONObject(a).getString("Proj_name").toString();
				project.add(projName[a]); // Listview에 프로젝트이름 추가

			}
		}catch(JSONException je){ 
			Log.e("jsonErr", "JSON에러 입니다", je);
		}catch(Exception e){ 
			Log.e("execption", "파일이 없습니다", e); 
		} 
	}
}
