package robust.pm.dbmanager;

import javax.servlet.http.HttpServlet;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import java.util.StringTokenizer;

public class DBCPInit extends HttpServlet {

    public void init(ServletConfig config) throws ServletException {
        try {
            String drivers = config.getInitParameter("jdbcdriver");	//DBMS Ҷ  JDBC ̹ ε
            StringTokenizer st = new StringTokenizer(drivers, ",");
            while (st.hasMoreTokens()) {
                String jdbcDriver = st.nextToken();
                Class.forName(jdbcDriver);
            }
            
            Class.forName("org.apache.commons.dbcp.PoolingDriver");	// DBCP API JDBC ̹
            
            // Ŀؼ Ǯ  XML мҶ  XMLм⸦ .
            // Ĺ(jdk1.4) ٸ  ڵּ ְ ˸° XML м⸦ Ѵ.
            System.setProperty("org.xml.sax.drvier",
                   "org.apache.crimson.parser.XMLReaderImpl");
        		//"org.apache.xerces.parsers.XMLParser");
        } catch(Exception ex) {
            throw new ServletException(ex);
        }
    }
}

