package robust.pm.task.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import robust.pm.dbmanager.DBCPConn;
import robust.pm.task.entity.tpart_psnEntity;

public class tpart_psnDAO {
	public boolean insertDB(tpart_psnEntity part_psn) {
		Connection conn = null;
		PreparedStatement pstmt = null;
		
		String sql = "insert into tpart_psn(prj_id, user_no) values(?,?)";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, part_psn.getPrj_id());
			pstmt.setString(2, part_psn.getUser_id());			
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}	

	//˻  user_no ʿ Ѱ Ƽ ߰  -2010.10.03 -
	public boolean deleteDB(int prj_id, int user_no) {
		Connection conn = null;
		PreparedStatement pstmt = null;
		String sql = "delete from tpart_psn where prj_id=? and user_no=?";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, prj_id);
			pstmt.setInt(2, user_no);
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}

	//˻  project_id ʿ Ѱ Ƽ ߰  -2010.10.03 -
	public ArrayList<tpart_psnEntity> get_UserDBList(int prj_id) {
		Connection conn = null;
		PreparedStatement pstmt = null;
		ArrayList<tpart_psnEntity> datas = new ArrayList<tpart_psnEntity>();

		String sql = "select * from tpart_psn where prj_id=?";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, prj_id);
			ResultSet rs = pstmt.executeQuery();

			while (rs.next()) {
				tpart_psnEntity tpart_psnEntityInstance = new tpart_psnEntity();

				tpart_psnEntityInstance.setPrj_id(rs.getInt("prj_id"));
				tpart_psnEntityInstance.setUser_id(rs.getString("user_id"));
				
				datas.add(tpart_psnEntityInstance);
			}
			rs.close();

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return datas;
	}
	
	//̺ Ư    ٰ Ǵؼ ּ ó . -2010.10.03 -
	//  ʿ ϴٸ sql  ʿ. where 
/*	public boolean updateDB(tpart_psnEntity part_psn) {
		connect();

	String sql = "update tpart_psn set prj_id=?, user_id=? where prj_id=? ";
	
		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1,part_psn.getPart_prj_id());
			pstmt.setInt(2, part_psn.getPart_user_id());
			
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			disconnect();
		}

		return true;
	}*/
}