package robust.pm.util;

public class HTMLUtil
{
	private static boolean str_char_cmp(char s[], int pos, int len, String str)
	{
		char c[] = str.toCharArray();
		int clen = str.length();
		int i;
		for(i=0; i<clen && pos+i<len; i++)
		{
			if(s[pos+i] != c[i])
				return false;
		}
		if(i<clen)
			return false;
		return true;
	}
     
	private static String convert_special(String str)
	{
		char s[] = str.toCharArray();
		int len = str.length();
		int i;
		String out = "";

		for(i = 0; i < len; i++)
		{
			/*
			if(s[i] == '&' && is_html_special_char(s,i,len) == false)
				out = out + "&amp;";
			else
				out = out + new String(s, i, 1);
			*/
			out = out + new String(s, i, 1);
		}
		return out;
	}

	private static boolean in_quotation(String str)
	{
		char s[] = str.toCharArray();
		int len = str.length();
		int i;

		for(i = 0; i < len; i++)
		{
			if(s[i] == '\\')
				i++;
			else if(s[i] == '"')
			{
				for(i++; i<len && s[i] != '"'; i++)
					if(s[i] == '\\')
						i++;
				if(i>=len)
					return true;
			}
			else if(s[i] == '\'')
			{
				for(i++; i<len && s[i] != '\''; i++)
					if(s[i] == '\\')
						i++;
				if(i>=len)
					return true;
			}
		}
		return false;
	}


	public static String replaceStr(String str,String orig, String replace) {
		if(str == null)
			return "";
		StringBuffer sb = new StringBuffer();
		int sIndex=0,eIndex=0;
		while( (eIndex=str.indexOf(orig,sIndex))>-1 && sIndex < str.length() ) {
			sb.append(str.substring(sIndex,eIndex)).append(replace);
			sIndex = eIndex+orig.length();	
		}
		sb.append(str.substring(sIndex, str.length()));
		
		return sb.toString();
	}


    private static int[] tagCount = null;
    
    public static int getTagCount(int i){
        if(tagCount == null)
            return 0;
        else
            return tagCount[i];
    }
    
    /**
     * ڹٽũƮ alert(..) ϴ HTML Ѵ. 
     * @param sMsg  ޽
     * @param isClose  â ݱ 
     * @return
     */
    public static String printAlert(String sMsg, boolean isClose) {
        return printAlert(sMsg, isClose, false);
    }
    
    /**
     * ڹٽũƮ alert(..) ϴ HTML Ѵ. 
     * @param sMsg  ޽
     * @param isClose  â ݱ 
     * @return
     */
    public static String printAlert(String sMsg, boolean isClose, boolean isHistoryBack) {
        StringBuffer sb = new StringBuffer();
        
        sb.append("<HTML>\n");
        sb.append("<SCRIPT>\n");
        sb.append("    alert(\"");
        sb.append(sMsg);
        sb.append("\");\n");
        if(isClose) {
            sb.append("    self.close();\n");
        }
        if(isHistoryBack) {
        	sb.append("    history.back(-1);\n");
        }
        sb.append("</SCRIPT>\n");
        sb.append("</HTML>\n");
        
        return sb.toString();
    }
    
    public static String getText(String cont) {
        String  cont2 = null;
        StringBuffer  cBuf = new StringBuffer(1000);
        char c;
        int len;

        int lineNum = 0;
        if(cont != null) {
            cBuf.setLength(0);
            len = cont.length();
            for (int i =0; i < len; i++) {
                c = cont.charAt(i);
                if (c == '\n'){
                    cBuf.append("<BR>\n");
                    lineNum++;
                }
                else if (c == ' ') cBuf.append("&nbsp;");
                else if (c == '<') cBuf.append("&lt;");
                else if (c == '>') cBuf.append("&gt;");
                else if (c == '"') cBuf.append("&quot;");
                else cBuf.append(c);
            }
            cont2 = cBuf.toString();
        }
        else {
            cont2 = "";
        }

        cBuf = null;
        return cont2;
    }
    
    public static String getText2(String cont) {
        String  cont2 = null;
        StringBuffer  cBuf = new StringBuffer(1000);
        char c;
        int len;

        if(cont != null) {
            cBuf.setLength(0);
            len = cont.length();
            for (int i =0; i < len; i++) {
                c = cont.charAt(i);
                
                if (c == '"') cBuf.append("&quot;");
                else cBuf.append(c);
            }
            cont2 = cBuf.toString();
        }
        else {
            cont2 = "";
        }

        cBuf = null;
        return cont2;
    }
}
